//	oop_ex63.java: Copy Constructors in Java (vs oop_ex58.cpp)


import java.io.*;
	
class vector
{
	private int[] data;
	private int size;	//note:for java, size is available via .length. Use it just for comparison

	public vector()	//default constructor
	{
		System.out.println("vector()");
		size = 0;
		data = new int[size];
	}

	public vector(int s)
	{
		System.out.println("vector(int s)");
		size = s;
		data = new int[size];

		for(int i=0; i<size; i++)
			data[i] = size;
	}

	//copy constructor------------------------------
	public vector(final vector v)		
	{
		System.out.println("vector(final vector& v)");
		size = v.size;
		
		data = new int[size];
		for(int i=0; i<size; i++)
			data[i] = v.data[i];
		
		//data = v.data;
	}
	//-----------------------------------------------


	void print()
	{
		for(int i=0; i<size; i++)
			System.out.print(data[i]+" ");

		System.out.println();
	}

	void printDataAddress()  //print the address of the allocated data array
	{
		System.out.println(data);
	}
};


class test
{
	public static void main(String[] args)
	{	
		vector p1 = new vector(10);
		vector p2 = new vector(p1);    //calling copy constructor

		System.out.println("the data of p1 : ");
		p1.print();
		System.out.println("the data of p2 : ");
		p2.print();

		System.out.println("the data address of p1 : ");
		p1.printDataAddress();
		System.out.println("the data address of p2 : ");
		p2.printDataAddress();
	}
}